//INCLUDEs
#include "stdafx.h"
#pragma warning(disable:4100)

//DEFINEs
#define APPNAME				"KeyCap v1.1\npart of S.T.A.L.K.E.R Keys MOD\nby HeEr0 [todor@mailshack.com]"
#define MUTEXNAME			"stalkerkeys"
#define STALKERWINDOWNAME	"S.T.A.L.K.E.R.: Shadow Of Chernobyl"
#define LTXFILE				"keys.ltx"
#define	LTXFILESECTION		"keycode"
#define LTXFILEKEY			"val"
#define DEFSLEEPTIME		100

//VARs
HANDLE hf = INVALID_HANDLE_VALUE;

//FUNCs
VOID cleanandexit(INT errcode);
VOID writeltx(LPSTR str);

//*************************************************************************************************************************
INT main(INT argc, LPSTR argv[])
{
	//get the parameters
	UINT sleeptime = DEFSLEEPTIME;
	if(argc > 1)
	{
		UINT num = atoi(argv[1]);
		if(num > 0) sleeptime = num;
	}

	//print title
	printf("%s\n\n",APPNAME);

	//--------------------------
	//check for another instance
	//--------------------------
	HANDLE hm = CreateMutex(NULL,FALSE,MUTEXNAME);
	if(hm != NULL)
	{	//mutex created
		if(GetLastError() == ERROR_ALREADY_EXISTS)
		{	//mutex exists
			printf("ERROR: Only one application instance is allowed\n");
			cleanandexit(1);
		}
	}

	//------------------------
	//set the process priority
	//------------------------
	if(SetPriorityClass(GetCurrentProcess(),HIGH_PRIORITY_CLASS) == 0)
	{	//ERROR
		printf("ERROR: SetPriorityClass()\n");
		cleanandexit(1);
	}

	//--------------
	//get the appdir
	//--------------
	CHAR appdir[MAX_PATH];
	if(GetModuleFileName(NULL,appdir,MAX_PATH) == 0)
	{	//ERROR
		printf("ERROR: GetModuleFileName()\n");
		cleanandexit(1);
	}
	PathRemoveFileSpec(appdir);

	//----------------------------
	//set the path to the LTX file
	//----------------------------
	CHAR ltxpath[MAX_PATH];
	_snprintf(ltxpath,MAX_PATH,"%s\\gamedata\\config\\%s",appdir,LTXFILE);

	//-------------------
	//create the LTX file
	//-------------------
	hf = CreateFile(
		ltxpath,
		GENERIC_WRITE,
		FILE_SHARE_READ|FILE_SHARE_WRITE,
		NULL,
		CREATE_ALWAYS,
		FILE_ATTRIBUTE_NORMAL,
		NULL
		);
	if(hf == INVALID_HANDLE_VALUE)
	{	//ERROR
		printf(
			"ERROR: CreateFile()\n"
			"Make sure this EXE is in the main STALKER directory\n"
			);
		cleanandexit(1);
	}

	//--------------------------
	//wait for the game to start
	//--------------------------
	BOOL bwaitgame = TRUE;

	printf("[*] Waiting for the game to start...\n");
	while(kbhit() == 0)
	{
		Sleep(sleeptime);

		if(FindWindow(NULL,STALKERWINDOWNAME) != NULL)
		{	//game window found
			if(bwaitgame == TRUE)
			{
				printf("[*] Capturing keycodes (Interval: %ums)...\n",sleeptime);
				bwaitgame = FALSE;
			}
			else
			{
				//write the section name
				SetFilePointer(hf,0,0,FILE_BEGIN);
				writeltx("["LTXFILESECTION"]\n");

				//capture the keystates
				const UINT valbuflen = 32;
				CHAR valbuf[valbuflen];
				ULONG codesum = 0;

				for(USHORT i = 1; i < 255; i++)
				{
					USHORT kst = GetKeyState(i);
					kst >>= 8;
					if(kst > 0)
					{	//key is down
						_snprintf(valbuf,valbuflen,"val%u = 1\n",i);
						codesum += i;
					}
					else
					{	//key is up
						_snprintf(valbuf,valbuflen,"val%u = 0\n",i);
					}

					//write the value
					writeltx(valbuf);
				}

				//print the codes
				printf("Keycodes: %03u\r",codesum);
			}
		}
		else
		{	//game window not found
			if(bwaitgame == FALSE) break;
		}
	}

	cleanandexit(0);
	return 0;
}

//*************************************************************************************************************************
VOID cleanandexit(INT errcode)
{
	if(errcode == 1)
	{
		printf("Press any key to exit...\n");
		while(kbhit() == 0) Sleep(100);
	}
	
	if(hf != INVALID_HANDLE_VALUE) CloseHandle(hf);

	exit(errcode);
}

//*************************************************************************************************************************
VOID writeltx(LPSTR str)
{
	ULONG written = 0;
	if(WriteFile(hf,str,strlen(str),&written,NULL) == 0)
	{	//ERROR
		printf("ERROR: WriteFile()\n");
		cleanandexit(1);
	}
}